//
// Created by nicolas on 22/03/18.
//

#include <stdarg.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "error.h"
#include "debug.h"

error_t* _error_create(const char* file, int line, int code, char* format, ...) {
    va_list vl;
    va_start(vl, format);
    error_t* err = malloc(sizeof(struct st_error));
    assert(err != 0);
    err->file = file;
    err->line = line;
    err->code = code;
    vsnprintf(err->message, ERROR_MSG_SIZE, format, vl);
    return err;
}
#define error_create(code, fmt, args...) _error_create(__FILE__, __LINE__, code, fmt, args)

error_t* error_copy(error_t* err) {
    error_t* copy = malloc(sizeof(error_t));
    memcpy(copy, err, sizeof(error_t));
    return copy;
}